<?php
/**
 * @package    	Simple Language Switcher
 * @version		1.0.0
 * @author	   	Premek
 * @copyright  	(C) 2017 Premek. All rights reserved.
 * @license http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL
 * @authorEmail	php@janyr.eu
 */

defined( '_JEXEC' ) or die;

abstract class modLangSimple
{
	static function display($params)
	{
		$uri = JURI::getInstance();
		if(preg_match('/index.php\/([a-z]{2})\//', $uri, $match, PREG_OFFSET_CAPTURE ))
		{
			JHtml::_('stylesheet', 'mod_languages/template.css', array(), true);
			$cur	= $match[1][0];
			$uri1	= substr($uri,0,$match[1][1]);
			$uri2	= substr($uri,$match[1][1] + 2);
			$navi	= $params->get('lsnavi', 1);
			$native	= $params->get('lsname', 1);
			$order	= $params->get('lsorder', 1);
			$cls	= 'lang-inline';
			$css	= $params->get('lsclass', '');
			if($css)
				$css	= ' ' . $css;
			switch($order)
			{
				case 2: // vertical
					$cls	= 'lang-block';
				case 1: // horizontal
					$output[]	= '<div class="mod-languages' . $css . '"><ul class="' . $cls . '">';
					break;
				case 0: // dropdown
					$output[]	= '<select class="inputbox' . $css . '" onchange="document.location.replace(this.value);">';
					break;
			}
			foreach(self::_languages() as $sef => $lang)
			{
				$name	= $native ? $lang->title_native : $lang->title;
				$src	= sprintf('%smedia/mod_languages/images/%s.gif', JUri::base(), $lang->image);
				$img	= sprintf('<img src="%1$s" title="%2$s" alt="%2$s" />', $src, $name);
				$link	= $uri1 . $sef . $uri2;
				switch($navi)
				{
					case 0: // Names
						$item	= $name;
						$src	= '';
						break;
					case 1:	// Flags
						$item	= $img;
						break;
					case 2:	// Flags & Names
						$item	= $img . '&nbsp;&nbsp;' . $name;
						break;
				}
				$output[]	= $order ? self::_li($link, $name, $item, $sef == $cur) : self::_option($link, $name, $src, $sef == $cur);
			}
			$output[]	= $order == 2 ? '</select>' : '</ul></div>';
			return implode('', $output);
		}
	}
	
	private static function _li($link, $name, $item, $selected)
	{
		if($selected)
			$selected	= ' class="lang-active"';
		return sprintf('<li%s><a href="%s" title="%s">%s</a></li>', $selected, $link, $name, $item);
	}
	
	private static function _option($link, $item, $src, $selected)
	{
		if($src)
			$src	= ' style="background-image: url(' . $src . '); background-repeat: no-repeat; padding-left: 24px;"';
		if($selected)
			$selected	= ' selected="true"';
		return sprintf('<option value="%s"%s%s>%s</option>', $link, $src, $selected, $item);
	}
	
	private static function _languages()
	{
		static $rx	= '/([a-z]{2,3})[-;]?([A-Z]{2})?/';
		$ours		= JLanguageHelper::getLanguages('sef');
		$his		= (new JApplicationWebClient())->__get('languages');
		$fb			= array();
		foreach($his as $hislang)
			if(preg_match($rx, $hislang, $hisrx))
			{
				$best	= null;
				foreach($ours as $key => $ourlang)
					if(preg_match($rx, $ourlang->lang_code, $ourrx)
					&& $ourrx[1] == $hisrx[1]
					&& (!$best || $ourrx[2] == $hisrx[2]))
						$best	= $ourlang;
				if($best)
					$fb[$best->sef]	= $best;
			}
		return array_merge($fb, $ours);
	}
}

echo modLangSimple::display($params);
